from model import *
from data import *
import numpy as np
import matplotlib.pyplot as plt
from scipy import stats

def calculate_rand_index(a,b):
    correct = 0
    total = 0
    for index1 in range(180):
        for index2 in range(180):

            same_class = (a[index1] == a[index2])
            same_cluster = (b[index1]
                            == b[index2])

            if same_class and same_cluster:
                correct += 1
            elif not same_class and not same_cluster:
                correct += 1

            total += 1

    return float(correct) / total
def change_color(idx, color):
    c1 = stats.mode(idx[0:60])[0][0]
    c2 = stats.mode(idx[60:120])[0][0]
    c3 = stats.mode(idx[120:180])[0][0]
    for i in range(180):
        if (idx[i] == c1):
            idx[i] = 0
        elif (idx[i] == c2):
            idx[i] = 1
        elif (idx[i] == c3):
            idx[i] = 2
    C = color[idx.astype(int)]
    return C

Color = np.array(['#EAAE20','#0071BC','#D65219'])

funcFilePath="data.csv"
locFilePath="loc.csv"
true_label_Path = "true_label.csv"
true_label = np.genfromtxt(true_label_Path, delimiter=',')
Data= data()
Data.readfile(funcFilePath,locFilePath)

print('GPMM : start')
Model1= gpModel(Data)
Model1.estimate(Data)
print('GPMM : finished')

print('GPSRE : start')
Model2=gpModelWithSpatialCorr(Data)
Model2.estimate(Data)
print('GPSRE : finished')

print('GPLoc : start')
Model3=gpModelLoc(Data)
Model3.estimate(Data)
print('GPLoc : finished')

print('Proposed : start')
Model4 = ProposedModel(Data)
Model4.estimate(Data)
print('Proposed : finished')

print('')
temp1 = np.zeros(180)
temp2 = np.zeros(180)
temp3 = np.zeros(180)
temp4 = np.zeros(180)
for i in range(180):
    temp1[i] = np.argmax(Model1.groupParam[i])
    temp2[i] = np.argmax(Model2.groupParam[i])
    temp3[i] = np.argmax(Model3.groupParam[i])
    temp4[i] = np.argmax(Model4.groupParam[i])

print('GP Rand index : %f' % calculate_rand_index(true_label, temp1))
print('GPSRE Rand index : %f'%calculate_rand_index(true_label,temp2))
print('GPLoc Rand index : %f' % calculate_rand_index(true_label, temp3))
print('Proposed Rand index : %f' % calculate_rand_index(true_label, temp4))

f1 = np.savetxt("Result_GPMM.txt", temp1.astype(int),fmt='%d', delimiter=',')
f2 = np.savetxt("Result_GPSRE.txt" , temp2.astype(int),fmt='%d', delimiter=',')
f3 = np.savetxt("Result_GPLoc.txt" , temp3.astype(int),fmt='%d', delimiter=',')
f4 = np.savetxt("Result_Proposed.txt" , temp4.astype(int),fmt='%d', delimiter=',')
plt.figure(1)
plt.scatter(Data.S[:,0],  Data.S[:,1],s=100,c=change_color(temp1,Color),edgecolors ='face')
plt.savefig('Result_GPMM.png')
plt.figure(2)
plt.scatter(Data.S[:,0],  Data.S[:,1],s=100,c=change_color(temp2,Color),edgecolors ='face')
plt.savefig('Result_GPSRE.png')
plt.figure(3)
plt.scatter(Data.S[:,0],  Data.S[:,1],s=100,c=change_color(temp3,Color),edgecolors ='face')
plt.savefig('Result_GPLoc.png')
plt.figure(4)
plt.scatter(Data.S[:,0],  Data.S[:,1],s=100,c=change_color(temp4,Color),edgecolors ='face')
plt.savefig('Result_Proposed.png')
plt.show()






